# --------------------------------------------------------------------------
# Copyright 1992-1993 by Forschungszentrum Informatik (FZI)
#
# You can use and distribute this software under the terms of the license
# version 1 you should have received along with this software.
# If not or if you want additional information, write to
# Forschungszentrum Informatik, "STONE", Haid-und-Neu-Strasse 10-14,
# D-76131 Karlsruhe, Germany.
# --------------------------------------------------------------------------

#
# This file contains some randomly collected code examples
#

#
# The running example from the 'The design ...' document.
#
proc example_loop {} {
   agg loop [mcall sos_Schema_module::schema_dir] {
      puts stdout "\t[[[agg current role2] get_name] make_Cstring]"
   }
}

#
# Print the contents of any collection...
#
proc print_collection {collection} {
   puts stdout "\ncardinality: [agg card $collection]"
   agg loop $collection {
       puts stdout "\t[agg current]"
   }
}

#
# first step: complete initialization
#
tclOBST bind

#
# Toying around with some temporary collections...
#

# get OBST constant, no abbreviations ...
set tmpCnt [OBST const TEMP_CONTAINER]
# ... same, but use abbreviations ...
set tmpCnt [OBST c T]
# oops - this should now work!
set tmpCnt [OBST c TE]

# Create temporary set, specify all arguments ...
set intSet [mcall sos_Int_Set::create $tmpCnt FALSE FALSE AGG_AUTOMATIC]
# ... destroy it ...
$intSet destroy
# ... and create it again, using default arguments.
set intSet [mcall sos_Int_Set::create $tmpCnt]

# Turn defaults off.
tclOBST customize allow_defaults false

# Create another kind of aggregate ...
set objBag [mcall sos_Object_Bag::create $tmpCnt]
# ... forgot that defaults are no longer allowed, so do it the long way ...
set objBag [mcall sos_Object_Bag::create $tmpCnt FALSE FALSE AGG_AUTOMATIC]

# Let's see, what we have so far...
print_collection $intSet
print_collection $objBag

# Now perform some insertions ...
$intSet insert 1
$intSet insert 1
$intSet insert 2
$objBag insert 1
# Ok, so we have to use the object representation instead
# (this is an object bag, no integer set).
$objBag insert [OBST s 1 sos_Int]

# Turn abbreviations off, so ...
tclOBST customize allow_abbrevs false
# ...
$objBag insert [OBST s 2 sos_Int]
# ... we have to use the full option name
$objBag insert [OBST scalar2obj 2 sos_Int]

# This is were we arrived at ...
print_collection $intSet
print_collection $objBag

# Clean up ...
$intSet destroy
$objBag destroy

# ... and now, it's up to you to figure out some useful tclOBST code!
